<?php


/**
 * Implementiert den VoIP Wizard
 *
 * @author Miguel Palmer <mp@beronet.com>
 */
class Voip {

	/**
	 * Generates the tones dropdown menu
	 * @param string $group Group name
	 * @param string $tones saved entry
	 * @return string
	 */
	function tones($group, $tones = "") {
		exec('/bin/cat /usr/conf/isgw.tones | /bin/grep "^\[.*\]$" ', $ausgabe);
		$disabled = (strpos($group, "FXS") !== FALSE) ? 'disabled' : '';
		$select = "<select class=\"form-control input-sm\" name=\"tones-$group\" id=\"tones-$group\" $disabled>";
		foreach ($ausgabe as $value) {

			if ($tones == "") {
				if ($value == "[de]") {
					$select.="<option value=\"" . $value . "\" selected>" . $value . "</option>";
				} elseif ($value != "[general]") {
					$select.="<option value=\"" . $value . "\">" . $value . "</option>";
				}
			} else {
				if ($value == $tones) {
					$select.="<option value=\"" . $value . "\" selected>" . $value . "</option>";
				} elseif ($value != "[general]") {
					$select.="<option value=\"" . $value . "\">" . $value . "</option>";
				}
			}
		}
		$select.="</select>";
		return $select;
	}

	function mapEntities($str) {
		return htmlentities(stripslashes($str), ENT_QUOTES);
	}

	/**
	 * Generates the HTML page
	 * @return string
	 */
	function display() {

		include("./misc/config_parameter.php");

		$name = 'VoIP PBX Wizard';
		if ($_SERVER['REQUEST_METHOD'] === 'POST') {
			$input = array_map(array($this, 'mapEntities'), $_POST);
		} else {
			$input = array_map(array($this, 'mapEntities'), $_GET);
		}
		if (isset($input['pbx']))
			$name = $input['pbx'] . " Wizard";

		$load = TRUE;
		if ((isset($input['pbx']) && isset($input['m']) && count($input) > 2) || (!isset($input['pbx']) && !isset($input['m']) && count($input) >= 1) || (!isset($input['pbx']) && isset($input['m']) && count($input) > 1) || (isset($input['pbx']) && !isset($input['m']) && count($input) > 1)) {
			$load = FALSE;
		}

		define("VOIP_PBX_WIZARD", $name);
		$name = "VOIP_PBX_WIZARD";
		include('./includes/header.php');
		require_once('./includes/lang.php');

		//Save
		$sent = $_POST['submit'];
		if ($sent == "Save") {
			$ret.=$this->createconfigfiles();
		}

		ob_start();
		?>
		<script type="text/javascript" language="javascript" src="./includes/js/ajaxfileupload.js"></script>
		<script type="text/javascript">
		    function confirmSubmit() {
		        var agree = confirm("Note !!! If you continue all previous configurations\n"
		                + "on the beroNet Gateway will be deleted. Press ok if want to proceed!\n"
		                + "New Config has to be activated and the gateway has to be rebooted.");
		        if (agree) {
		            $("input").attr("disabled", false);
		            return true;
		        } else {
		            return false;
		        }
		    }
		    function bri(port) {
		        if (!$("#ptp-BRI" + port).attr('checked') && $("#intern-BRI" + port).attr('checked')) {
		            $("[name='group-BRI" + port + "']").val("Phone" + port);
		            $("[name='group-BRI" + port + "']").attr("disabled", true);
		        } else {
		            $("[name='group-BRI" + port + "']").attr("disabled", false);
		        }

		    }
		    function intern(id, tones, port) {
		        if ($("#" + id).prop('checked')) {
		            $("#div_intern" + id).remove();
		        } else {
		            if ($('#isdn_intern').html() != "") {
		                hr = "<div class='clearfix'></div><hr style='width:80%;'>";
		            } else {
		                hr = "";
		            }
		            $('#isdn_intern').append("<div id='div_intern" + id + "'>" + hr +
		                    "<div class='col-sm-2'>" +
		                    "<div class='form-group'>" +
		                    "<label for='port[]' class='col-sm-8 control-label'>Port " + id + "</label>" +
		                    "<div class='col-sm-1'>" +
		                    "<input type='checkbox' value='" + id + "' name='port[]' checked>" +
		                    "<input type='hidden' value='nt' name='ntte-" + port + "'>" +
		                    "<input type='hidden' value='0' name='ptp-" + port + "'>" +
		                    "<input type='hidden' value='ISDN-Intern" + port + "' name='group-ISDN-" + port + "'>" +
		                    "</div>" +
		                    "</div>" +
		                    "</div>" +
		                    "<div class='col-sm-10'>" +
		                    "<div class='form-group'>" +
		                    "<label for='user-isdn-" + port + "' class='col-sm-5 control-label'>User</label>" +
		                    "<div class='col-sm-6'>" +
		                    "<input name='user-isdn-" + port + "' class='form-control input-sm'>" +
		                    "</div>" +
		                    "</div>" +
		                    "<div class='form-group'>" +
		                    "<label for='password-isdn-" + port + "' class='col-sm-5 control-label'>Password</label>" +
		                    "<div class='col-sm-6'>" +
		                    "<input name='password-isdn-" + port + "' type='password' class='form-control input-sm'>" +
		                    "</div>" +
		                    "</div>" +
		                    "<div class='form-group'>" +
		                    "<label for='tones' class='col-sm-5 control-label'>For which country should the tonset be configured</label>" +
		                    "<div class='col-sm-6'>" +
		                    tones +
		                    "</div>" +
		                    "</div>" +
		                    "</div>" +
		                    "</div>");
		        }
		    }
		    function fxs_change(port) {
		        $("input[name=password-fxs-" + port + "]").prop("disabled", !$("#FXS-" + port).prop("checked"));
		        $("input[name=user-fxs-" + port + "]").prop("disabled", !$("#FXS-" + port).prop("checked"));
		        $("#tones-FXS-" + port).prop("disabled", !$("#FXS-" + port).prop("checked"));
		    }
		    function ajaxFileUpload() {
		        $.ajaxFileUpload({
		            url: "modules/Voip/ajax-voip.php",
		            secureuri: false,
		            fileElementId: "csvfile",
		            dataType: "json",
		            success: function (data, status)
		            {
		                if (typeof (data.error) != "undefined") {
		                    if (data.error != "") {
		                        alert(data.error);
		                    } else {
		                        var lines = data.file;
		                        lines = lines.split(";");
		                        $(".fxs").removeAttr("checked");
		                        $.each(lines, function (index, line) {
		                            var prop = line.split(",");
		                            $("input[value='FXS-" + prop[0] + "']").prop("checked", "checked");
		                            $("input[name='user-fxs-" + prop[0] + "']").prop("value", prop[1]);
		                            $("input[name='password-fxs-" + prop[0] + "']").prop("value", prop[2]);
		                            $("#tones-FXS-" + prop[0] + " option[value='" + prop[3] + "']").prop("selected", true);
		                        });
		                    }
		                }
		            },
		            error: function (data, status, e)
		            {
		                alert(e);
		            }
		        });
		        return false;
		    }
		</script>
		<?php
		$ret.=ob_get_clean();


		if ($err != 0) {
			ob_start();
			?>
			<div class='text-center'>
				<font face='Loma,Sans,Arial' size='3' color='#FF0000'>Error occured. Please check the marked fields below.</font>
			</div>
			<br>
			<?php
			$ret.= ob_get_clean();
		}
		$ba = new beroAri();

		$lif = Helper::getLif();
		ob_start();
		?>
		<form action='' enctype='multipart/form-data' method='POST' id='voip' class="form-horizontal">
			<input type='password' name='dummy' style='display:none;'>
			<br>
			<br>
			<div class="text-center">
				<p class='lead'>VoIP PBX Settings</p>
			</div>
			<div class='form-group'>
				<label for='server_address' class='col-sm-5 control-label'>Server Address</label>
				<div class='col-sm-6'>
					<input name='server_address' class='form-control input-sm' id='server_address' value='<? echo $input['server-address'] ?>'>
				</div>
			</div>
			<div class='form-group'>
				<label for='server_port' class='col-sm-5 control-label'>Port</label>
				<div class='col-sm-6'>
					<input name='server_port' class='form-control input-sm' id='server_port' value='<? echo $input['server-port'] ?>'>
				</div>
			</div>
			<hr>
			<br>
			<?php
			$ret .= ob_get_clean();

			//HEADER
			for ($i = 0; $i < Helper::getLifCount(); $i++) {
				switch ($lif[$i]) {
					case "bf4S0":
						$types[$i] = "BRI";
						$ports[$i] = "4";
						$start[$i] = "isdn";
						break;
					case "bf2S0":
						$types[$i] = "BRI";
						$ports[$i] = "2";
						$start[$i] = "isdn";
						break;
					case "bf1S0":
						$types[$i] = "BRI";
						$ports[$i] = "1";
						$start[$i] = "isdn";
						break;
					case "bf1t1e1":
						$t1e1 = true;
					case "bf1E1":
						$types[$i] = "PRI";
						$ports[$i] = "1";
						$start[$i] = "isdn";
						break;
					case "bf2t1e1":
						$t1e1 = true;
					case "bf2E1":
						$types[$i] = "PRI";
						$ports[$i] = "2";
						$start[$i] = "isdn";
						break;
					case "bf4t1e1":
						$t1e1 = true;
						$types[$i] = "PRI";
						$ports[$i] = "4";
						$start[$i] = "isdn";
						break;
					case "bf2S02FXS":
						$types[$i] = "BRI/FXS";
						$ports[$i] = "2";
						$start[$i] = "isdn/analog";
						break;
					case "bf4FXS":
						$types[$i] = "FXS";
						$ports[$i] = "4";
						$start[$i] = "analog";
						break;
					case "bf8FXS":
						$types[$i] = "FXS";
						$ports[$i] = "8";
						$start[$i] = "analog";
						break;
					case "bf1FXS":
						$types[$i] = "FXS";
						$ports[$i] = "1";
						$start[$i] = "analog";
					case "bf4FXO":
						$types[$i] = "FXO";
						$ports[$i] = "4";
						$start[$i] = "analog";
						break;
					case "bf2FXO":
						$types[$i] = "FXO";
						$ports[$i] = "2";
						$start[$i] = "analog";
						break;
					case "bf1GSM":
						$types[$i] = "GSM";
						$ports[$i] = "1";
						$start[$i] = "gsm";
						break;
					case "bf2GSM":
						$types[$i] = "GSM";
						$ports[$i] = "2";
						$start[$i] = "gsm";
						break;
					case "unknown":
						$types[$i] = "unknown";
						$ports[$i] = "0";
						break;
				}
			}
			// ISDN PRI
			if (in_array('PRI', $types)) {
				$startPort = 1;
				foreach ($types as $li => $type) {
					if ($type == "PRI") {
						if ($checkPri != "") {
							ob_start();
							?>
							<br>
							<?php
							$checkPri.=ob_get_clean();
						}
						ob_start();
						?>
						Available Ports Lif<? echo $li ?> (PRI):
						<?php
						$checkPri.=ob_get_clean();
						$control = $startPort + $ports[$li];
						for ($j = $startPort; $j < $control; $j++) {
							ob_start();
							?>
							<input type='checkbox' value='PRI-<? echo $j ?>' id='PRI-<? echo $j ?>' name='port[]' checked><? echo $j ?>
							<?php
							$checkPri.=ob_get_clean();
						}
						$startPort = $startPort + $ports[$li];
					} elseif ($start[$li] == "isdn" || $start[$li] == "isdn/analog") {
						$startPort = $startPort + $ports[$li];
					}
				}
				$countryCodePri = ($input['isdn-extern-country-code-pri'] != "") ? $input['isdn-extern-country-code-pri'] : $ba->get('international_code');
				$cityCodePri = ($input['isdn-extern-city-code-pri'] != "") ? $input['isdn-extern-city-code-pri'] : $ba->get('national_code');
				ob_start();
				?>

				<br>
				<div class="text-center">
					<p class='lead'>ISDN Extern PRI</p>
				</div>
				<div class='form-group'>
					<label for='port[]' class='col-sm-5 control-label'>Select your external ISDN PRI lines</label>
					<div class='col-sm-6'>
						<? echo $checkPri ?>
					</div>
				</div>
				<div class='form-group'>
					<label for='extern-ntte-PRI' class='col-sm-5 control-label'>Are lines Terminal Endpoint (TE) or Network Terminator (NT)?</label>
					<div class='col-sm-6'>
						<select name='extern-ntte-PRI' class='form-control input-sm' id='extern-ntte-PRI'>
							<option size='40' value='nt'>nt</option>
							<option size='40' value='te' selected>te</option>
						</select>
						<input type='hidden' value='ISDN-Extern-PRI' name='extern-group-ISDN-PRI'>
					</div>
				</div>
				<? if ($t1e1 === true) { ?>
					<div class='form-group'>
						<label for='extern-t1e1-PRI' class='col-sm-5 control-label'>Are lines T1 or E1?</label>
						<div class='col-sm-6'>
							<select class='form-control input-sm' name='extern-t1e1-PRI' id='extern-t1e1-PRI'>
								<option size='40' value='t1' selected>t1</option>
								<option size='40' value='e1'>e1</option>
							</select>
						</div>
					</div>

				<? } ?>

				<div class='form-group'>
					<label for='ISDN-extern-user-PRI' class='col-sm-5 control-label'>User</label>
					<div class='col-sm-6'>
						<input name='ISDN-extern-user-PRI' class='form-control input-sm' value='<? echo $input['isdn-extern-user-pri'] ?>'>
					</div>
				</div>
				<div class='form-group'>
					<label for='ISDN-extern-password-PRI' class='col-sm-5 control-label'>Password</label>
					<div class='col-sm-6'>
						<input type='password' name='ISDN-extern-password-PRI' value='<? echo $input['isdn-extern-password-pri'] ?>' class='form-control input-sm'>
					</div>
				</div>
				<div class='form-group'>
					<label for='tones' class='col-sm-5 control-label'>For which country should the tonset be configured?</label>
					<div class='col-sm-6'>
						<? echo $this->tones('ISDN-Extern-PRI', $input['isdn-extern-tones-pri']) ?>
					</div>
				</div>
				<div class='form-group' data-toggle='tooltip' title='<? echo ISDN_COUNTRY_CODE ?>'>
					<label for='ISDN-extern-country_code-PRI' class='col-sm-5 control-label'><? echo PSTN_COUNTRY_CODE_DIS ?></label>
					<div class='col-sm-6'>
						<input name='ISDN-extern-country_code-PRI' value='<? echo $countryCodePri ?>' class='form-control input-sm'>
					</div>
				</div>
				<div class='form-group' data-toggle='tooltip' title='<? echo ISDN_CITY_CODE ?>'>
					<label for='ISDN-extern-city_code-PRI' class='col-sm-5 control-label'><? echo PSTN_CITY_CODE_DIS ?></label>
					<div class='col-sm-6'>
						<input name='ISDN-extern-city_code-PRI' value='<? echo $cityCodePri ?>' class='form-control input-sm'>
					</div>
				</div>
				<div class='form-group' data-toggle='tooltip' title='<? echo ISDN_LOCAL_AREA_CODE ?>'>
					<label for='ISDN-extern-local_area_code-PRI' class='col-sm-5 control-label'><? echo PSTN_LOCAL_AREA_CODE_DIS ?></label>
					<div class='col-sm-6'>
						<input name='ISDN-extern-local_area_code-PRI' value='<? echo $input['isdn-extern-local-area-code-pri'] ?>' class='form-control input-sm'>
					</div>
				</div>
				<div class='form-group' data-toggle='tooltip' title='<? echo OTON ?>'>
					<label for='ISDN-extern-oton-PRI' class='col-sm-5 control-label'><? echo DIALPLAN_OTON_DIS ?></label>
					<div class='col-sm-6'>
						<? echo tons('ISDN-extern-oton-PRI') ?>
					</div>
				</div>
				<hr>
				<?php
				$ret.= ob_get_clean();
			}
			// ISDN BRI
			if (in_array('BRI', $types) || in_array('BRI/FXS', $types)) {
				$startPort = 1;
				foreach ($types as $li => $type) {
					if ($type == "BRI" || $type == "BRI/FXS") {
						if ($checkBri != "") {
							ob_start();
							?>
							<br>
							<?php
							$checkBri.=ob_get_clean();
						}
						ob_start();
						?>
						Available Ports Lif<? echo $li ?> (BRI):
						<?php
						$checkBri.=ob_get_clean();
						$control = $startPort + $ports[$li];
						for ($j = $startPort; $j < $control; $j++) {
							$tones = $this->tones('BRI-' . $j);
							ob_start();
							?>
							<input type='checkbox' value='BRI-<? echo $j ?>' id='BRI-<? echo $j ?>'  name='port[]' checked onchange="intern('BRI-<? echo $j ?>', '<? echo htmlspecialchars($tones) ?>', '<? echo $j ?>');"><? echo $j ?>
							<?php
							$checkBri.=ob_get_clean();
						}
						$startPort = $startPort + $ports[$li];
					} elseif ($start[$li] == "isdn" || $start[$li] == "isdn/analog") {
						$startPort = $startPort + $ports[$li];
					}
				}
				$countryCodeBri = ($input['isdn-extern-country-code-bri'] != "") ? $input['isdn-extern-country-code-bri'] : $ba->get('international_code');
				$cityCodeBri = ($input['isdn-extern-city-code-bri'] != "") ? $input['isdn-extern-city-code-bri'] : $ba->get('national_code');
				ob_start();
				?>
				<br>
				<div class="text-center">
					<p class='lead'>ISDN Extern BRI</p>
				</div>
				<div class='form-group'>
					<label for='port[]' class='col-sm-5 control-label'>Select your external ISDN BRI lines</label>
					<div class='col-sm-6'>
						<? echo $checkBri ?>
					</div>
				</div>
				<div class='form-group'>
					<label for='ptp' class='col-sm-5 control-label'>Are lines Point to Point (PTP) or Point to Multi Point (PTMP)?</label>
					<div class='col-sm-6'>
						<select name='ptp' class='form-control input-sm' id='ptp'>
							<option name='ptp' size='40' value='1' selected>PTP</option>
							<option name='ptmp' size='40' value='0'>PTMP</option>
						</select>
						<input type='hidden' value='te' name='extern-ntte-BRI'>
						<input type='hidden' value='ISDN-Extern-BRI' name='extern-group-ISDN-BRI'>
					</div>
				</div>
				<div class='form-group'>
					<label for='ISDN-extern-user-BRI' class='col-sm-5 control-label'>User</label>
					<div class='col-sm-6'>
						<input name='ISDN-extern-user-BRI' value='<? echo $input['isdn-extern-user-bri'] ?>' class='form-control input-sm'>
					</div>
				</div>
				<div class='form-group'>
					<label for='ISDN-extern-password-BRI' class='col-sm-5 control-label'>Password</label>
					<div class='col-sm-6'>
						<input type='password' name='ISDN-extern-password-BRI' value='<? echo $input['isdn-extern-password-bri'] ?>' class='form-control input-sm'>
					</div>
				</div>
				<div class='form-group'>
					<label for='tones' class='col-sm-5 control-label'>For which country should the tonset be configured?</label>
					<div class='col-sm-6'>
						<? echo $this->tones('ISDN-Extern-BRI', $input['isdn-extern-tones-bri']) ?>
					</div>
				</div>
				<div class='form-group' data-toggle='tooltip' title='<? echo ISDN_COUNTRY_CODE ?>'>
					<label for='ISDN-extern-country_code-BRI' class='col-sm-5 control-label'><? echo PSTN_COUNTRY_CODE_DIS ?></label>
					<div class='col-sm-6'>
						<input name='ISDN-extern-country_code-BRI' value='<? echo $countryCodeBri ?>' class='form-control input-sm'>
					</div>
				</div>
				<div class='form-group' data-toggle='tooltip' title='<? echo ISDN_CITY_CODE ?>'>
					<label for='ISDN-extern-city_code-BRI' class='col-sm-5 control-label'><? echo PSTN_CITY_CODE_DIS ?></label>
					<div class='col-sm-6'>
						<input name='ISDN-extern-city_code-BRI' value='<? echo $cityCodeBri ?>' class='form-control input-sm'>
					</div>
				</div>
				<div class='form-group' data-toggle='tooltip' title='<? echo ISDN_LOCAL_AREA_CODE ?>'>
					<label for='ISDN-extern-local_area_code-BRI' class='col-sm-5 control-label'><? echo PSTN_LOCAL_AREA_CODE_DIS ?></label>
					<div class='col-sm-6'>
						<input name='ISDN-extern-local_area_code-BRI' value='<? echo $input['isdn-extern-local-area-code-bri'] ?>' class='form-control input-sm'>
					</div>
				</div>
				<div class='form-group' data-toggle='tooltip' title='<? echo OTON ?>'>
					<label for='ISDN-extern-oton-BRI' class='col-sm-5 control-label'><? echo DIALPLAN_OTON_DIS ?></label>
					<div class='col-sm-6'>
						<? echo tons('ISDN-extern-oton-BRI') ?>
					</div>
				</div>
				<hr>
				<br>
				<div class="text-center">
					<p class='lead'>ISDN Intern: Select your internal ISDN lines</p>
				</div>
				<div id='isdn_intern'></div>
				<div class="clearfix"></div>
				<hr>
				<?php
				$ret .= ob_get_clean();
			}

			if (in_array('GSM', $types)) {
				ob_start();
				?>
				<br>
				<div class="text-center">
					<p class='lead'>GSM Extern</p>
				</div>
				<div class='form-group'>
					<label for='port[]' class='col-sm-5 control-label'>Select your external GSM lines</label>
					<div class='col-sm-6'>
						<?php
						$ret.=ob_get_clean();
						$startPort = 1;
						foreach ($types as $li => $type) {
							if ($type == "GSM") {
								$control = $startPort + $ports[$li];
								for ($j = $startPort; $j < $control; $j++) {
									ob_start();
									?>
									<input type='checkbox' name='port[]' id='GSM-<? echo $j ?>' value='GSM-<? echo $j ?>' checked><? echo $j ?>
									<input type='hidden' value='GSM-Extern' name='group-GSM-<? echo $j ?>'>
									<?php
									$ret.=ob_get_clean();
								}
								$startPort = $startPort + $ports[$li];
							} elseif ($start[$li] == "gsm") {
								$startPort = $startPort + $ports[$li];
							}
						}
						ob_start();
						?>
						<input type='hidden' value='GSM-Extern' name='group-GSM'>
					</div>
				</div>
				<div class='form-group'>
					<label for='GSM-extern-user' class='col-sm-5 control-label'>User</label>
					<div class='col-sm-6'>
						<input name='GSM-extern-user' value='<? echo $input['gsm-extern-user'] ?>' class='form-control input-sm'>
					</div>
				</div>
				<div class='form-group'>
					<label for='GSM-extern-password' class='col-sm-5 control-label'>Password</label>
					<div class='col-sm-6'>
						<input type='password' name='GSM-extern-password' value='<? echo $input['gsm-extern-password'] ?>' class='form-control input-sm'>
					</div>
				</div>
				<hr>
				<?php
				$ret.=ob_get_clean();
			}

			if (in_array('FXO', $types)) {
				ob_start();
				?>
				<br>
				<div class="text-center">
					<p class='lead'>FXO Extern</p>
				</div>
				<div class='form-group'>
					<label for='port[]' class='col-sm-5 control-label'>Select your external FXO lines</label>
					<div class='col-sm-6'>
						<?php
						$ret .= ob_get_clean();
						$startPort = 1;
						foreach ($types as $li => $type) {
							if ($type == "FXO") {
								$control = $startPort + $ports[$li];
								for ($j = $startPort; $j < $control; $j++) {
									ob_start();
									?>
									<input type='checkbox' name='port[]' id='FXO-<? echo $j ?>' value='FXO-<? echo $j ?>' checked><? echo $j ?>
									<input type='hidden' value='FXO-Extern' name='group-FXO-<? echo $j ?>'>
									<?php
									$ret .= ob_get_clean();
								}
								$startPort = $startPort + $ports[$li];
							} elseif ($start[$li] == "analog" || $start[$li] == "isdn/analog") {
								$startPort = $startPort + $ports[$li];
							}
						}
						ob_start();
						?>
					</div>
				</div>
				<div class='form-group'>
					<label for='FXO-extern-user' class='col-sm-5 control-label'>User</label>
					<div class='col-sm-6'>
						<input name='FXO-extern-user' value='<? echo $input['fxo-extern-user'] ?>' class='form-control input-sm'>
					</div>
				</div>
				<div class='form-group'>
					<label for='FXO-extern-password' class='col-sm-5 control-label'>Password</label>
					<div class='col-sm-6'>
						<input type='password' name='FXO-extern-password' value='<? echo $input['fxo-extern-password'] ?>' class='form-control input-sm'>
					</div>
				</div>
				<div class='form-group'>
					<label for='tones' class='col-sm-5 control-label'>For which country should the tonset be configured?</label>
					<div class='col-sm-6'>
						<? echo $this->tones('FXO-Extern', $input['fxo-extern-tones']) ?>
					</div>
				</div>
				<hr>
				<?php
				$ret.= ob_get_clean();
			}

			if (in_array('FXS', $types) || in_array('BRI/FXS', $types)) {
				ob_start();
				?>
				<br>
				<div class="text-center">
					<p class='lead'>FXS Intern: Select your internal FXS lines</p>
				</div>
				<div class='form-group'>
					<label for='csvfile' class='col-sm-2 control-label'>CSV File</label>
					<div class='col-sm-4'>
						<input type='file'  id='csvfile' name='csvfile'>
					</div>
					<div class='col-sm-2'>
						<input type='button' class='btn btn-default' value='Upload' onclick='ajaxFileUpload();' name='upload'>
					</div>
				</div>
				<div class='row'>
					<div class='col-sm-3'><strong>Port</strong></div>
					<div class='col-sm-3'><strong>User</strong></div>
					<div class='col-sm-3'><strong>Password</strong></div>
					<div class='col-sm-3'><strong>Tones</strong></div>
				</div>
						<?php
						$ret .= ob_get_clean();

						$startPort = 1;
						foreach ($types as $li => $type) {
							if ($type == "FXS" || $type == "BRI/FXS") {
								$control = $startPort + $ports[$li];
								for ($j = $startPort; $j < $control; $j++) {
									$checked = "";
									$script = "";
									if ($input['fxs-' . $j] == 1) {
										$checked = "checked";
										$script = "<script>fxs_change($j);</script>";
									}
									ob_start();
									?>
								<div class='row'>
									<div class='col-sm-3'>
										<div class='form-group'>
											<label for='port[]' class='col-sm-2 control-label'><? echo $j ?></label>
											<div class='col-sm-5'>
												<input type='checkbox' class='FXS' id='FXS-<? echo $j ?>' value='FXS-<? echo $j ?>' name='port[]' onchange='fxs_change(<? echo $j ?>);' <? echo $checked ?>>
												<input type='hidden' value='FXS-Intern-<? echo $j ?>' name='group-FXS-<? echo $j ?>'>
											</div>
										</div>
									</div>
									<div class='col-sm-3'>
										<input name='user-fxs-<? echo $j ?>' value='<? echo $input['user-fxs-' . $j] ?>' disabled class='form-control input-sm'>
									</div>
									<div class='col-sm-3'>
										<input type='password' name='password-fxs-<? echo $j ?>' value='<? echo $input['password-fxs-' . $j] ?>' disabled class='form-control input-sm'>
									</div>
									<div class='col-sm-3'>
										<? echo $this->tones("FXS-" . $j, $input["tones-fxs-" . $j]) . $script ?>
									</div>
								</div>
								<?php
								$ret .= ob_get_clean();
							}
							$startPort = $startPort + $ports[$li];
						} elseif ($start[$li] == "analog" || $start[$li] == "isdn/analog") {
							$startPort = $startPort + $ports[$li];
						}
					}
				$ret .= ob_get_clean();
			}
			//FOOTER
			ob_start();
			?>
			<br><br>
			<div class='text-center'><input type='submit' class='btn btn-default' name='submit' value='Save' onClick='return confirmSubmit()'></div>
		</form>
			<script type="text/javascript">
			$(document).ready(function(){
				$("#voip").validate({
		            rules: {
		                server_address: {
		                    required: true,
		                },
		            },
		            highlight: function (element) {
		                $(element).closest('.form-group').addClass('has-error');
		            },
		            unhighlight: function (element) {
		                $(element).closest('.form-group').removeClass('has-error');
		            },
		            errorPlacement: function (error, element) {
		                error.appendTo(element.closest('.col-sm-6'));
		            }
		        });
			});
			</script>
		<br>
		<?php
		$ret .= ob_get_clean();
		if ($load) {
			$ret .= $this->load();
		}

		return $ret;
	}

	/**
	 * Saves the configuration to the database
	 * @return string
	 */
	function createconfigfiles() {

		$strpath = "/usr/conf/";
		@unlink($strpath . "ari.db");
		$ba = new beroAri();

		$conf_content = "[general]\n";
		$conf_content.="server_address=" . $_POST['server_address'] . "\n";
		$conf_content.="server_port=" . $_POST['server_port'] . "\n\n";


		//PSTN Config
		foreach ($_POST["port"] as $value) {
			$port = explode("-", $value);
			switch ($port[0]) {
				case "BRI":
					$tones = $_POST["tones-BRI-" . $port[1]];
					if ($tones == "")
						$tones = $_POST["tones-ISDN-Extern-BRI"];
					$country_code = $_POST['ISDN-extern-country_code-BRI'];
					$city_code = $_POST['ISDN-extern-city_code-BRI'];
					$local_area_code = $_POST['ISDN-extern-local_area_code-BRI'];
					$oton = $_POST['ISDN-extern-oton-BRI'];
					if ($oton != "")
						$config = "oton=" . $oton;
					$group = $_POST["group-ISDN-" . $port[1]];
					//Externe Gruppe
					if ($group == "") {
						//Liste der Ports für die Config File
						$isdn_port_BRI.=$port[1] . ",";
						$group = $_POST["extern-group-ISDN-BRI"];
					}
					$ptp = $_POST["ptp-" . $port[1]];
					if ($ptp == "")
						$ptp = $_POST["ptp"];
					$ntte = $_POST["ntte-" . $port[1]];
					if ($ntte == "")
						$ntte = $_POST["extern-ntte-BRI"];

					$ba->update("UPDATE isdn SET gr='" . sqlite_escape_string($group) . "', ptp='" . sqlite_escape_string($ptp) . "', ntteSW='" . sqlite_escape_string($ntte) . "', ntteHW='" . sqlite_escape_string($ntte) . "', tones='" . sqlite_escape_string($tones) . "', country_code='" . sqlite_escape_string($country_code) . "', city_code='" . sqlite_escape_string($city_code) . "', local_area_code='" . sqlite_escape_string($local_area_code) . "', config='" . sqlite_escape_string($config) . "' WHERE port='" . sqlite_escape_string($port[1]) . "'");
					break;
				case "PRI":
					$tones = $_POST["tones-ISDN-Extern-PRI"];
					$isdn_port_PRI.=$port[1] . ",";
					$group = $_POST["extern-group-ISDN-PRI"];
					$ntte = $_POST["extern-ntte-PRI"];
					$t1e1 = $_POST["extern-t1e1-PRI"];
					$country_code = $_POST['ISDN-extern-country_code-PRI'];
					$city_code = $_POST['ISDN-extern-city_code-PRI'];
					$local_area_code = $_POST['ISDN-extern-local_area_code-PRI'];
					$oton = $_POST['ISDN-extern-oton-PRI'];
					if ($oton != "")
						$config = "oton=" . $oton;
					$config = $ba->update("UPDATE isdn SET gr='" . sqlite_escape_string($group) . "', ntteSW='" . sqlite_escape_string($ntte) . "', ntteHW='" . sqlite_escape_string($ntte) . "', tones='" . sqlite_escape_string($tones) . "', country_code='" . sqlite_escape_string($country_code) . "', city_code='" . sqlite_escape_string($city_code) . "', local_area_code='" . sqlite_escape_string($local_area_code) . "', config='" . sqlite_escape_string($config) . "' WHERE port='" . sqlite_escape_string($port[1]) . "'");
					if ($t1e1 != "")
						$ba->update("UPDATE cas SET protocol='" . sqlite_escape_string($t1e1) . "', termination='" . sqlite_escape_string($ntte) . "' where port_type='hdlc'");
					break;
				case "FXO":
					//Liste der Ports für die Config File
					$analog_port.=$port[1] . ",";
					$group = $_POST["group-FXO-" . $port[1]];
					$tones = $_POST["tones-FXO-Extern"];

					$ba->update("UPDATE analog SET gr='" . sqlite_escape_string($group) . "', tones='" . sqlite_escape_string($tones) . "' WHERE port='" . sqlite_escape_string($port[1]) . "'");
					break;
				case "GSM":
					//Liste der Ports für die Config File
					$gsm_port.=$port[1] . ",";
					$group = $_POST["group-GSM"];

					$ba->update("UPDATE gsm SET gr='" . sqlite_escape_string($group) . "' WHERE port='" . sqlite_escape_string($port[1]) . "'");
					break;
				case "FXS":
					$group = $_POST["group-FXS-" . $port[1]];
					$tones = $_POST["tones-FXS-" . $port[1]];
					$ba->update("UPDATE analog SET gr='" . sqlite_escape_string($group) . "', tones='" . sqlite_escape_string($tones) . "' WHERE port='" . sqlite_escape_string($port[1]) . "'");
					break;
				default:
					break;
			}
		}


		//SIP & Dialplan config
		$dest = "(.*)";
		$newdest = "\\\\1";
		$src = "(.*)";
		$newsrc = "\\\\1";
		$activ = 1;
		$posId = 0;
		$config = "sip_from_user_setting=\${account_username}";
		if ($_GET['pbx'] == "3CX") {
			$config = $config . ",from_sip_src_setting=from_display";
		}

		$ip = exec('/sbin/ifconfig eth0 | sed -ne "s/.*inet addr:\(.*\) Bcast.*/\1/p"');
		//isdn
		$query = $ba->select('SELECT DISTINCT gr, port_type FROM isdn WHERE gr!="NULL"');
		while ($entry = $ba->fetch_array($query)) {
			$name = "SIP-" . $entry['gr'];
			$user = $_POST['ISDN-extern-user-' . $entry['port_type']];
			$secret = $_POST['ISDN-extern-password-' . $entry['port_type']];
			$server_adress = $_POST['server_address'];
			if ($_POST['server_port'] != '')
				$server_adress.=":" . $_POST['server_port'];
			$register = 1;
			$activ = 1;

			if (preg_match('/ISDN-Intern([0-9])+/', $entry['gr'], $match)) {
				$user = $_POST['user-isdn-' . $match[1]];
				$secret = $_POST['password-isdn-' . $match[1]];
				//The matchtype for intern sip accounts is touser
				$matchtype = 'touser';
				$conf_content.="[" . $entry['gr'] . "]\n";
				$conf_content.="port=" . $match[1] . "\n";
				$conf_content.="user=" . $user . "\n";
				$conf_content.="password=" . $secret . "\n";
				$conf_content.="type=" . $entry['port_type'] . "\n";
				$conf_content.="tones=\"" . $_POST["tones-" . $entry['port_type'] . "-" . $match[1]] . "\"\n\n";
				$ba->insert_("INSERT INTO sip (name, sip_registrar, sip_domain, sip_proxy, user, secret, register, matchtype, config)
					VALUES ('" . sqlite_escape_string($name) . "','" . sqlite_escape_string($server_adress) . "', '" . sqlite_escape_string($server_adress) .
					"', '" . sqlite_escape_string($server_adress) . "', '" . sqlite_escape_string($user) . "', '" . sqlite_escape_string($secret) . "', '" .
					sqlite_escape_string($register) . "', '" . sqlite_escape_string($matchtype) . "', '" . sqlite_escape_string($config) . "')");
				//Dialplan Rule ISDN=>SIP
				$toid = "p:" . $name;
				$fromid = "g:" . $entry['gr'];
				$query_new = $ba->insert_("INSERT INTO dialplan (fromDirection, toDirection, fromId, toId, dest, newDest, src, newSrc, posId, activ, config) VALUES ('isdn','sip','" . sqlite_escape_string($fromid) . "','" . sqlite_escape_string($toid) . "', '" . sqlite_escape_string($dest) . "', '" . sqlite_escape_string($newdest) . "', '" . sqlite_escape_string($src) . "', '" . sqlite_escape_string($newsrc) . "',  '" . sqlite_escape_string($posId++) . "', '" . sqlite_escape_string($activ) . "', '" . sqlite_escape_string($config) . "')");
				//Dialplan Rule SIP=>ISDN
				$fromid = "a:" . $name;
				$toid = "g:" . $entry['gr'];
				$query_new = $ba->insert_("INSERT INTO dialplan (fromDirection, toDirection, fromId, toId, dest, newDest, src, newSrc, posId, activ) VALUES ('sip','isdn','" . sqlite_escape_string($fromid) . "','" . sqlite_escape_string($toid) . "', '" . sqlite_escape_string($dest) . "', '" . sqlite_escape_string($newdest) . "', '" . sqlite_escape_string($src) . "', '" . sqlite_escape_string($newsrc) . "',  '" . sqlite_escape_string($posId++) . "', '" . sqlite_escape_string($activ) . "')");
			} else {
				//Extern Group
				$trunk_config = "sip_ppi_user_setting=\${new source}";
				$trunk_config = $trunk_config . ",from_sip_src_setting=ppi_user";
				$conf_content.="[" . $entry['gr'] . "]\n";
				$conf_content.="port=" . trim(${'isdn_port_' . $entry['port_type']}, ",") . "\n";
				$conf_content.="user=" . $user . "\n";
				$conf_content.="password=" . $secret . "\n";
				if ($entry['port_type'] == "BRI")
					$conf_content.="ptp=" . $_POST["ptp"] . "\n";
				if ($entry['port_type'] == "PRI") {
					$conf_content.="ntte=" . $_POST["extern-ntte-PRI"] . "\n";
					$conf_content.="t1e1=" . $_POST["extern-t1e1-PRI"] . "\n";
				}
				$conf_content.="tones=\"" . $_POST["tones-ISDN-Extern-" . $entry['port_type']] . "\"\n";
				$conf_content.="country_code=\"" . $_POST["ISDN-extern-country_code-" . $entry['port_type']] . "\"\n";
				$conf_content.="city_code=\"" . $_POST["ISDN-extern-city_code-" . $entry['port_type']] . "\"\n";
				$conf_content.="local_area_code=\"" . $_POST["ISDN-extern-local_area_code-" . $entry['port_type']] . "\"\n";
				$conf_content.="oton=\"" . $_POST["ISDN-extern-oton-" . $entry['port_type']] . "\"\n\n";
				$ba->insert_("INSERT INTO sip (name, sip_registrar, sip_domain, sip_proxy, user, secret, register, config)
					VALUES ('" . sqlite_escape_string($name) . "','" . sqlite_escape_string($server_adress) . "', '"
					. sqlite_escape_string($server_adress) . "','" . sqlite_escape_string($server_adress) . "','"
					. sqlite_escape_string($user) . "', '" . sqlite_escape_string($secret) . "', '" . sqlite_escape_string($register) . "', '"
					. sqlite_escape_string($config) . "')");
				//Dialplan Rule ISDN=>SIP
				$toid = "p:" . $name;
				$fromid = "g:" . $entry['gr'];
				$query_new = $ba->insert_("INSERT INTO dialplan (fromDirection, toDirection, fromId, toId, dest, newDest, src, newSrc, posId, activ, config) VALUES ('isdn','sip','" . sqlite_escape_string($fromid) . "','" . sqlite_escape_string($toid) . "', '" . sqlite_escape_string($dest) . "', '" . sqlite_escape_string($newdest) . "', '" . sqlite_escape_string($src) . "', '" . sqlite_escape_string($newsrc) . "',  '" . sqlite_escape_string($posId++) . "', '" . sqlite_escape_string($activ) . "', '" . sqlite_escape_string($config) . "')");
				//Dialplan Rule SIP=>ISDN
				$fromid = "d:" . $name;
				$toid = "g:" . $entry['gr'];
				$query_new = $ba->insert_("INSERT INTO dialplan (fromDirection, toDirection, fromId, toId, dest, newDest, src, newSrc, posId, activ) VALUES ('sip','isdn','" . sqlite_escape_string($fromid) . "','" . sqlite_escape_string($toid) . "', '" . sqlite_escape_string($dest) . "', '" . sqlite_escape_string($newdest) . "', '" . sqlite_escape_string($src) . "', '" . sqlite_escape_string($newsrc) . "',  '" . sqlite_escape_string($posId++) . "', '" . sqlite_escape_string($activ) . "')");
			}
		}
		//analog
		$query = $ba->select('SELECT DISTINCT gr, port_type FROM analog WHERE gr!="NULL"');
		while ($entry = $ba->fetch_array($query)) {
			$name = "SIP-" . $entry['gr'];
			$user = $_POST['FXO-extern-user'];
			$secret = $_POST['FXO-extern-password'];
			$server_adress = $_POST['server_address'];
			$trunk_config = "sip_ppi_user_setting=\${new source}";
			$trunk_config = $trunk_config . ",from_sip_src_setting=ppi_user";
			if ($_POST['server_port'] != '')
				$server_adress.=":" . $_POST['server_port'];
			$register = 1;
			if ($entry['port_type'] == "FXS") {
				preg_match('/FXS-Intern-([0-9]+)+/', $entry['gr'], $match);
				$user = $_POST['user-fxs-' . $match[1]];
				$secret = $_POST['password-fxs-' . $match[1]];
				//The matchtype for intern sip accounts is touser
				$matchtype = 'touser';
				$conf_content.="[" . $entry['gr'] . "]\n";
				$conf_content.="port=" . $match[1] . "\n";
				$conf_content.="user=" . $user . "\n";
				$conf_content.="password=" . $secret . "\n";
				$conf_content.="tones=\"" . $_POST["tones-" . $entry['port_type'] . "-" . $match[1]] . "\"\n\n";
				$ba->insert_("INSERT INTO sip (name, sip_registrar, sip_proxy, sip_domain, user, secret, register, matchtype)
					VALUES ('" . sqlite_escape_string($name) . "','" . sqlite_escape_string($server_adress) . "', '" .
					sqlite_escape_string($server_adress) . "','" . sqlite_escape_string($server_adress) . "','" .
					sqlite_escape_string($user) . "', '" . sqlite_escape_string($secret) . "', '" .
					sqlite_escape_string($register) . "', '" . sqlite_escape_string($matchtype) . "')");
				//Dialplan Rule ANALOG=>SIP
				$toid = "p:" . $name;
				$fromid = "g:" . $entry['gr'];
				$query_new = $ba->insert_("INSERT INTO dialplan (fromDirection, toDirection, fromId, toId, dest, newDest, src, newSrc, posId, activ, config) VALUES ('analog','sip','" . sqlite_escape_string($fromid) . "','" . sqlite_escape_string($toid) . "', '" . sqlite_escape_string($dest) . "', '" . sqlite_escape_string($newdest) . "', '" . sqlite_escape_string($src) . "', '" . sqlite_escape_string($newsrc) . "',  '" . sqlite_escape_string($posId++) . "', '" . sqlite_escape_string($activ) . "','" . sqlite_escape_string($config) . "')");
				//Dialplan Rule SIP=>ANALOG
				$fromid = "a:" . $name;
				$toid = "g:" . $entry['gr'];
				$query_new = $ba->insert_("INSERT INTO dialplan (fromDirection, toDirection, fromId, toId, dest, newDest, src, newSrc, posId, activ) VALUES ('sip','analog','" . sqlite_escape_string($fromid) . "','" . sqlite_escape_string($toid) . "', '" . sqlite_escape_string($dest) . "', '" . sqlite_escape_string($newdest) . "', '" . sqlite_escape_string($src) . "', '" . sqlite_escape_string($newsrc) . "',  '" . sqlite_escape_string($posId++) . "', '" . sqlite_escape_string($activ) . "')");
			} else {
				//Extern Group
				$conf_content.="[" . $entry['gr'] . "]\n";
				$conf_content.="port=" . trim($analog_port, ",") . "\n";
				$conf_content.="user=" . $user . "\n";
				$conf_content.="password=" . $secret . "\n";
				$conf_content.="tones=\"" . $_POST["tones-FXO-Extern"] . "\"\n\n";
				$ba->insert_("INSERT INTO sip (name, sip_registrar, sip_domain, sip_proxy, user, secret, register, config)
					VALUES ('" . sqlite_escape_string($name) . "','" . sqlite_escape_string($server_adress) . "', '" .
					sqlite_escape_string($server_adress) . "','" . sqlite_escape_string($server_adress) . "','" .
					sqlite_escape_string($user) . "', '" . sqlite_escape_string($secret) . "', '" .
					sqlite_escape_string($register) . "', '" . sqlite_escape_string($trunk_config) . "')");
				//Dialplan Rule ANALOG=>SIP
				$toid = "p:" . $name;
				$fromid = "g:" . $entry['gr'];
				$query_new = $ba->insert_("INSERT INTO dialplan (fromDirection, toDirection, fromId, toId, dest, newDest, src, newSrc, posId, activ, config) VALUES ('analog','sip','" . sqlite_escape_string($fromid) . "','" . sqlite_escape_string($toid) . "', '" . sqlite_escape_string($dest) . "', '" . sqlite_escape_string($newdest) . "', '" . sqlite_escape_string($src) . "', '" . sqlite_escape_string($newsrc) . "',  '" . sqlite_escape_string($posId++) . "', '" . sqlite_escape_string($activ) . "','" . sqlite_escape_string($config) . "')");
				//Dialplan Rule SIP=>ANALOG
				$fromid = "d:" . $name;
				$toid = "g:" . $entry['gr'];
				$query_new = $ba->insert_("INSERT INTO dialplan (fromDirection, toDirection, fromId, toId, dest, newDest, src, newSrc, posId, activ) VALUES ('sip','analog','" . sqlite_escape_string($fromid) . "','" . sqlite_escape_string($toid) . "', '" . sqlite_escape_string($dest) . "', '" . sqlite_escape_string($newdest) . "', '" . sqlite_escape_string($src) . "', '" . sqlite_escape_string($newsrc) . "',  '" . sqlite_escape_string($posId++) . "', '" . sqlite_escape_string($activ) . "')");
			}
		}
		//gsm
		$query = $ba->select('SELECT DISTINCT gr, port_type FROM gsm WHERE gr!="NULL"');
		while ($entry = $ba->fetch_array($query)) {
			$name = "SIP-" . $entry['gr'];
			$user = $_POST['GSM-extern-user'];
			$secret = $_POST['GSM-extern-password'];
			$server_adress = $_POST['server_address'];
			if ($_POST['server_port'] != '')
				$server_adress.=":" . $_POST['server_port'];
			$register = 0;
			$trunk_config = "sip_ppi_user_setting=\${new source}";
			$trunk_config = $trunk_config . ",from_sip_src_setting=ppi_user";
			$conf_content.="[" . $entry['gr'] . "]\n";
			$conf_content.="port=" . trim($gsm_port, ",") . "\n";
			$conf_content.="user=" . $user . "\n";
			$conf_content.="password=" . $secret . "\n\n";

			$ba->insert_("INSERT INTO sip (name, sip_registrar, sip_domain, sip_proxy, user, secret, register, config)
				VALUES ('" . sqlite_escape_string($name) . "','" . sqlite_escape_string($server_adress) . "','" .
				sqlite_escape_string($server_adress) . "','" . sqlite_escape_string($server_adress) . "', '" .
				sqlite_escape_string($user) . "', '" . sqlite_escape_string($secret) . "', '" .
				sqlite_escape_string($register) . sqlite_escape_string($trunk_config) . "')");
			//Dialplan Rule GSM=>SIP
			$toid = "p:" . $name;
			$fromid = "g:" . $entry['gr'];
			$query_new = $ba->insert_("INSERT INTO dialplan (fromDirection, toDirection, fromId, toId, dest, newDest, src, newSrc, posId, activ) VALUES ('gsm','sip','" . sqlite_escape_string($fromid) . "','" . sqlite_escape_string($toid) . "', '" . sqlite_escape_string($dest) . "', '" . sqlite_escape_string($newdest) . "', '" . sqlite_escape_string($src) . "', '" . sqlite_escape_string($newsrc) . "',  '" . sqlite_escape_string($posId++) . "', '" . sqlite_escape_string($activ) . "')");
			//Dialplan Rule SIP=>GSM
			$fromid = "d:" . $name;
			$toid = "g:" . $entry['gr'];
			$query_new = $ba->insert_("INSERT INTO dialplan (fromDirection, toDirection, fromId, toId, dest, newDest, src, newSrc, posId, activ) VALUES ('sip','gsm','" . sqlite_escape_string($fromid) . "','" . sqlite_escape_string($toid) . "', '" . sqlite_escape_string($dest) . "', '" . sqlite_escape_string($newdest) . "', '" . sqlite_escape_string($src) . "', '" . sqlite_escape_string($newsrc) . "',  '" . sqlite_escape_string($posId++) . "', '" . sqlite_escape_string($activ) . "')");
		}

		$ret = Helper::activate(3, true, 'Voip');
		file_put_contents("/usr/conf/voip-wizard.conf", $conf_content);
		return $ret;
	}

	/**
	 * Load the settings fromt the config file
	 * @return string
	 */
	function load() {
		$file_path = "/usr/conf/voip-wizard.conf";
		if (!file_exists($file_path))
			return;
		$result = parse_ini_file($file_path, true);
		$ret = "<script>$('input[type=\"checkbox\"]').removeAttr('checked');";
		foreach ($result as $section => $values) {
			switch (true) {
				case $section == "general":
					$server = $result[$section][server_address];
					$port = $result[$section][server_port];
					$ret.= "$('#server_address').val('" . $server . "');"
						. "$('#server_port').val('" . $port . "');";
					break;

				case $section == "ISDN-Extern-BRI":
					$ports = explode(",", $result[$section][port]);
					foreach ($ports as $port)
						$ret.= "$('#BRI-" . $port . "').prop('checked','checked');";
					$user = $result[$section][user];
					$ret.= "$('input[name=\"ISDN-extern-user-BRI\"]').val('" . $user . "');";
					$password = $result[$section][password];
					$ret.= "$('input[name=\"ISDN-extern-password-BRI\"]').val('" . $password . "');";
					$country_code = $result[$section][country_code];
					$ret.= "$('input[name=\"ISDN-extern-country_code-BRI\"]').val('" . $country_code . "');";
					$city_code = $result[$section][city_code];
					$ret.= "$('input[name=\"ISDN-extern-city_code-BRI\"]').val('" . $city_code . "');";
					$local_area_code = $result[$section][local_area_code];
					$ret.= "$('input[name=\"ISDN-extern-local_area_code-BRI\"]').val('" . $local_area_code . "');";
					$ptp = $result[$section][ptp];
					$ret.= "$('#ptp option[value=\"" . $ptp . "\"]').prop('selected',true);";
					$tones = $result[$section][tones];
					$ret.= "$('#tones-ISDN-Extern-BRI option[value=\"" . $tones . "\"]').prop('selected',true);";
					$oton = $result[$section][oton];
					$ret.= "$('#ISDN-extern-oton-BRI option[value=\"" . $oton . "\"]').prop('selected',true);";
					break;

				case $section == "ISDN-Extern-PRI":
					$ports = explode(",", $result[$section][port]);
					foreach ($ports as $port)
						$ret.= "$('#PRI-" . $port . "').prop('checked','checked');";
					$user = $result[$section][user];
					$ret.= "$('input[name=\"ISDN-extern-user-PRI\"]').val('" . $user . "');";
					$password = $result[$section][password];
					$ret.= "$('input[name=\"ISDN-extern-password-PRI\"]').val('" . $password . "');";
					$country_code = $result[$section][country_code];
					$ret.= "$('input[name=\"ISDN-extern-country_code-PRI\"]').val('" . $country_code . "');";
					$city_code = $resulcityt[$section][city_code];
					$ret.= "$('input[name=\"ISDN-extern-city_code-PRI\"]').val('" . $city_code . "');";
					$local_area_code = $resulcityt[$section][local_area_code];
					$ret.= "$('input[name=\"ISDN-extern-local_area_code-PRI\"]').val('" . $local_area_code . "');";
					$ntte = $result[$section][ntte];
					$ret.= "$('#extern-ntte-PRI option[value=\"" . $ntte . "\"]').prop('selected',true);";
					$t1e1 = $result[$section][t1e1];
					$ret.= "$('#extern-t1e1-PRI option[value=\"" . $t1e1 . "\"]').prop('selected',true);";
					$tones = $result[$section][tones];
					$ret.= "$('#tones-ISDN-Extern-PRI option[value=\"" . $tones . "\"]').prop('selected',true);";
					$oton = $result[$section][oton];
					$ret.= "$('#ISDN-extern-oton-PRI option[value=\"" . $oton . "\"]').prop('selected',true);";
					break;

				case $section == "ISDN-Intern" . substr($section, strlen("ISDN-Intern")):
					$port = $result[$section][port];
					$user = $result[$section][user];
					$password = $result[$section][password];
					$tones = $result[$section][tones];
					$type = $result[$section][type];
					$tones_sel = $this->tones($type . '-' . $port);
					$ret.= "intern('" . $type . "-" . $port . "', '" . $tones_sel . "', '" . $port . "');";
					$ret.= "$('input[name=\"user-isdn-" . $port . "\"]').val('" . $user . "');";
					$ret.= "$('input[name=\"password-isdn-" . $port . "\"]').val('" . $password . "');";
					$ret.= "$('#tones-" . $type . "-" . $port . " option[value=\"" . $tones . "\"]').prop('selected',true);";
					break;

				case $section == "FXO-Extern":
					$ports = explode(",", $result[$section][port]);
					foreach ($ports as $port)
						$ret.= "$('#FXO-" . $port . "').prop('checked','checked');";
					$user = $result[$section][user];
					$ret.= "$('input[name=\"FXO-extern-user\"]').val('" . $user . "');";
					$password = $result[$section][password];
					$ret.= "$('input[name=\"FXO-extern-password\"]').val('" . $password . "');";
					$tones = $result[$section][tones];
					$ret.= "$('#tones-FXO-Extern option[value=\"" . $tones . "\"]').prop('selected',true);";
					break;

				case $section == "GSM-Extern":
					$ports = explode(",", $result[$section][port]);
					foreach ($ports as $port)
						$ret.= "$('#GSM-" . $port . "').prop('checked','checked');";
					$user = $result[$section][user];
					$ret.= "$('input[name=\"GSM-extern-user\"]').val('" . $user . "');";
					$password = $result[$section][password];
					$ret.= "$('input[name=\"GSM-extern-password\"]').val('" . $password . "');";
					break;

				case $section == "FXS-Intern-" . substr($section, strlen("FXS-Intern-")):
					$port = $result[$section][port];
					$user = $result[$section][user];
					$password = $result[$section][password];
					$tones = $result[$section][tones];
					$ret.= "$('#FXS-" . $port . "').prop('checked','checked');";
					$ret.= "$('input[name=\"user-fxs-" . $port . "\"]').val('" . $user . "');";
					$ret.= "$('input[name=\"password-fxs-" . $port . "\"]').val('" . $password . "');";
					$ret.= "$('#tones-FXS-" . $port . " option[value=\"" . $tones . "\"]').prop('selected',true);";
					$ret.= "fxs_change($port);";
					break;

				default:
					break;
			}
		}
		$ret.= "</script>";
		return $ret;
	}

}
